//Programa para el proyecto de la Rocola Digital, tercera versión.
//Version comentada, con botones de cambio y de pausa, además de una led para ambientación.

//Incluír todas las librerías necesarias (Librería para el LCD)
#include <LiquidCrystal.h>
LiquidCrystal lcd(12, 11, 7, 6, 5, 4);


//PARTE MUSICAL DE LA ROCOLA

//MARIO:
//Notas de Mario
float NM[] = {164.81, 130.81, 196,  98,  82.41, 110, 123.47, 116.54, 220, 174.61, 146.83, 185,     0,          261.63,  233.08,  87.31, 73.42, 77.78, 155.56, 138.59, 103.83, 207.65, 92.50};
            //MIo      DOo    SOLo  SOL   MI     LA    SI     LA#    LAo   FAo     REo    FA#o  Silencio(12)    DOoo      LA#o    FA     RE     RE#    RE#o    DO#o    SOL#    SOL#o  FA#

//Set de notas:
//Array de notas para la canción "MARIO THEME"
float N1[] = {0, 0, 0, 1, 0, 2, 3, 12, 1, 3, 4, 5, 6, 7, 5, 3, 12, 0, 2, 8, 9, 2, 0, 1, 10, 6, 12, 1, 3, 4, 5, 6, 7, 5, 3, 12, 0, 2, 8, 9, 2, 0, 1, 10, 6, 12,
              2, 11, 9, 10, 0, 3, 5, 6, 5, 1, 10, 12, 2, 11, 9, 10, 5, 1, 1, 1, 12}; //i = 67
//Array de notas para la canción "UNDER GROUND"
float N2[] = {1, 13, 5, 8, 7, 14, 12, 12, 1, 13,  5, 8, 7, 14, 12, 12, 15, 9, 16, 10,17, 18, 12, 12, 15, 9, 16, 10, 17, 18, 12, 12, 18, 10, 19, 1, 18, 10, 20, 3, 19, 1, 12, 12, 11,
              9, 0, 14, 8, 21, 18, 1, 7, 5, 20}; //i = 55
//Array de notas para la canción "BOWSERS CASTLE"
float N3[] = {17, 16, 22, 15, 4, 7, 5, 4, 17, 4, 12, 17, 16, 22, 15, 4, 7, 5, 4, 17, 4, 12,17, 16, 22, 15, 4, 7, 5, 4, 17, 4, 12, 12, 1, 1, 3, 10, 10, 10, 1, 6, 6, 1, 12, 12, 1, 3, 
              4, 5, 6, 5, 20, 7, 20, 4, 16, 5, 12, 12}; //i = 60



//Definir variables y constantes
int NOCANCION = 0; 
int UP = 8;
int DOWN = 9;
int BUZZ = 13;
int PAUSA = 1;
int PAUSA2 = 1;
int STOP = 3;

//FUNCION NOTES, esta función sevirá para reproducir una nota específica 
//dento del loop del programa
void NOTES(int NOTE){
  tone(13, NM[NOTE]); 
 delay(170);
  noTone(13);
 delay(100);
}

//FUNCIÓN INTERRUPCION, esta función servira para interrumpir una canción y cambiarla de 
//a otra mientras se reproduce
void INTERRUPCION(){
   int STATE2 = digitalRead(DOWN); //Verificación del estado de los botones
   int STATE = digitalRead(UP);
   //Registro de ambos botones para salir del loop de la canción
  if(STATE2 == HIGH || STATE == HIGH){
    if(PAUSA == 1){
      PAUSA = 0;
    }
  }
 //Registro del estado del boton de "UP" y cambio del contador +1
  if(STATE == HIGH){
    if(NOCANCION == 0){
      NOCANCION++;
  }
    else if(NOCANCION == 1){
      NOCANCION++;
  }
    else{
      NOCANCION = 0;
  }
 }

 //Registro del estado del boton de "DOWN" y cambio del contador -1
 if(STATE2 == HIGH){
  if(NOCANCION == 2){
    NOCANCION--;
  }
  else if(NOCANCION == 1){
    NOCANCION--;
  }
  else{
    NOCANCION = 2;
  }
 }
 while(digitalRead(DOWN) == HIGH); //Evita rebotes
 while(digitalRead(UP) == HIGH); //Evita rebotes
}


//FUNCION INTERRUPCION2, Pausará indefinidamente el programa hasta su pulsación otra vez
void INTERRUPCION2(){
int  STATE3 = digitalRead(STOP); //Verificación del boton para pausar la Rockola
  if(STATE3 == HIGH){
    if(PAUSA2 == 1){
      PAUSA2 = 0;
    }
  else if(PAUSA2 == 0){
    PAUSA2 = 1;
  }
  }
  while(digitalRead(STOP) == HIGH); //Evita rebotes
}


//FUNCION SETUP de inicialización  
void setup(){
  Serial.begin(9600); //Inicialización del monitor serial para feedback

  //Inicialización de pines y LCD
  pinMode(UP, INPUT);
  pinMode(DOWN, INPUT);
  pinMode(BUZZ, HIGH);
  pinMode(STOP, INPUT);
  lcd.begin(16,2);
  lcd.clear();
}


//Principal cuerpo del programa
void loop(){

//Verificación del contador "NOCANCION" 
  if(NOCANCION == 0){
    //Reproducción de la canción número 1
    Serial.println(NOCANCION); //Impresión de la canción en Monitor Serial

    //Configuración del LCD
    lcd.clear(); 
    lcd.home(); 
    lcd.print("  WORLD  1 - 1");
    lcd.setCursor(0, 1);
    lcd.print("  Mario  Theme");

    //Reproducción de la canción
    //Se reproduce un ciclo con la cantidad de notas donde siempre se
    //reprodice la nota y se verifica con contadores no cambien para
    //seguir con la canción o cambiar o pausar según sea el caso.
    for(int i = 0; i <= 66; i++){
        NOTES(N1[i]); //Reproduccion de una nota
        if(PAUSA == 0){
          PAUSA = 1;
        }
        INTERRUPCION();
        if(PAUSA == 0){
          break; //Break de la canción cuando se presione el botón necesario
        }
         //Stop y Play de la canción
         while(PAUSA2 == 0){
          INTERRUPCION2();
         }
         INTERRUPCION2();
    }
  }
  else if(NOCANCION == 1){
    //Reproducción de la canción número 2
    Serial.println(NOCANCION); //Impresión de la canción en Monitor Serial

    //Configuración del LCD
    lcd.clear();
    lcd.home();
    lcd.print("  WORLD  1 - 2");
    lcd.setCursor(0, 1);
    lcd.print("  Under ground");

    for(int j = 0; j <= 54; j++){
    NOTES(N2[j]); //Reproduccion de una nota
    if(PAUSA == 0){
      PAUSA = 1;
    }
    INTERRUPCION();
    if(PAUSA == 0){
      break; //Break de la canción cuando se presione el botón necesario
     }
     //Stop y Play de la canción
     while(PAUSA2 == 0){
     INTERRUPCION2();
       }
    INTERRUPCION2();
    }
  }
  
  else if(NOCANCION == 2){
    //Reproducción de la canción número 3
    Serial.println(NOCANCION); //Impresión de la canción en Monitor Serial

    //Configuración del LCD
    lcd.clear();
    lcd.home();
    lcd.print("  WORLD  1 - 4");
    lcd.setCursor(0, 1);
    lcd.print(" Bowsers Castle");

    for(int z = 0; z <= 59; z++){
    NOTES(N3[z]); //Reproduccion de una nota
    if(PAUSA == 0){
      PAUSA = 1;
    }
    INTERRUPCION();
    if(PAUSA == 0){
      break; //Break de la canción cuando se presione el botón necesario
     }
     //Stop y Play de la canción
     while(PAUSA2 == 0){
       INTERRUPCION2();
      }
     INTERRUPCION2();
    }
  }
  delay(200); //delay general para evitar problemas
}
